General Date & Time pickers Event Calendar Form components Responsive list Numeric pickers Pickers & dropdowns Layout & navigation Tools Accessibility

Timer

Basic usage

Javascript
// create a timer
mobiscroll.timer('#timer', {
    theme: 'ios', 
    display: 'bottom'
});
HTML
<input id="timer"/>

Typescript Types

When using with typescript, the following types are available for the Timer:

Type Description
Timer Type of the Timer instance
MbscTimerOptions Type of the settings object that is used to initialize the component

For many more examples - simple and complex use-cases - check out the timer demos for javascript.

Options

Name Type Default value Description
anchor String, HTMLElement undefined Specifies the anchor element for positioning, if display is set to 'bubble' . If undefined, it defaults to the element on which the component was initialized.
animate String or Boolean undefined Animation to use for show/hide (if display is not inline). Possible values:
  • 'fade'
  • 'flip'
  • 'pop'
  • 'swing'
  • 'slidevertical'
  • 'slidehorizontal'
  • 'slidedown'
  • 'slideup'
If false, turns the animation off.
autostart Boolean false If true, the timer will automatically start on initialization.
buttons Array ['resetlap', 'toggle'] List of buttons to display. Possible values:
  • 'resetlap' - Reset / Lap button.
  • 'toggle' - Start / Stop button.
  • 'start' - Start button.
  • 'stop' - Stop button.
  • 'reset' - Reset button.
  • 'lap' - Lap button.
  • 'hide' - Hide button.
circular Boolean, Array undefined If true, the scroll wheels are circular. If an array, it can be specified as a per wheel configuration, e.g. for 3 wheels: [true, false, false] - sets the first wheel circular. If not specified, if a wheel has more values than the number of displayed rows, the scroll wheel becomes circular.
closeOnOverlayTap Boolean true If true, the popup is closed on overlay tap/click.
context String, HTMLElement 'body' The DOM element in which the component is appended and positioned (if not inline). Can be a selector string or a DOM element.
cssClass String undefined Applies custom css class to the top level element.
disabled Boolean false Initial disabled state of the component. This will take no effect in inline display mode.
display String 'center' Controls the positioning of the component. Possible options:
  • 'center' - The component appears as a popup at the center of the viewport.
  • 'inline' - If called on div element, the component is placed inside the div (overwriting existing content), otherwise is placed after the original element.
  • 'bubble' - The component appears as a bubble positioned to the element defined by the anchor option. By default the anchor is the original element.
  • 'top' - The component appears docked to the top of the viewport.
  • 'bottom' - The component appears docked to the bottom of the viewport.
focusOnClose Boolean, String, HTMLElement true Element to focus after the popup is closed. If undefined, the original element will be focused. If false, no focusing will occur.
focusTrap Boolean true If not in inline mode, focus won't be allowed to leave the popup.
headerText Boolean, String, Function false Specifies a custom string which appears in the popup header.
If the string contains the '{value}' substring, it is replaced with the formatted value of the timer.
If it's set to false, the header is hidden.
If a function is passed, it receives the formatted value as parameter and the returned value appears in the header.
height Number 40 Height in pixels of one item on the wheel. The default value depends on the theme:

Mobiscroll: 40
Android Holo: 36
Bootstrap: 40
iOS: 34
jQuery Mobile: 40
Material: 40
Windows Phone: 76
layout String undefined Sets the layout of the component. Possible values:
  • 'liquid' - Wheels will expand to the maximum available width, but will not exceed the width set by the maxWidth setting. If maxWidth is not specified, the total width of all wheels will not exceed 600px. In 'top' or 'bottom' display mode this is the default behavior.
  • 'fixed' or undefined - Wheels will expand to the size of the longest wheel value, but will not exceed the width set by the maxWidth setting.
maxWheel String undefined Specifies the highest wheel to display. If not set, the highest wheel is calculated based on the targetTime setting.

Possible values:
  • 'years'
  • 'months'
  • 'days'
  • 'hours'
  • 'minutes'
  • 'seconds'
  • 'fract'
maxWidth Number or Array undefined Maximum width of the wheels. If number, it is applied to all wheels, if an array, it is applied to each wheel separately.
minWidth Number or Array 80 Minimum width of the wheels in pixels. If number, it is applied to all wheels, if an array, it is applied to each wheel separately. The default value depends on the theme:

Mobiscroll: 80
Android Holo: 76
Bootstrap: 80
iOS: 55
jQuery Mobile: 80
Material: 80
Windows Phone: 76
mode String 'countdown' Option to choose between modes. Possible values:
  • 'countdown' - Timer counting down from target time to 0.
  • 'stopwatch' - Stopwatch mode.
multiline Number 1 If greater than 1, the wheel item's content will be wrapped into the specified number of lines. If the content is shorter, it will remain vertically centered.
readonly Boolean or Array false If true, the component is displayed, but the values are not selectable. If an array, it can be specified as a per wheel configuration, e.g. for 3 wheels: [true, false, false] - sets the first wheel readonly.
responsive Object undefined Specify different settings for different container widths, in a form of an object, where the keys are the name of the breakpoints, and the values are objects containing the settings for the given breakpoint.
The available width is queried from the container element of the component and not the browsers viewport like in css media queries
There are five predefined breakpoints:
  • xsmall - min-width: 0px
  • small - min-width: 576px
  • medium - min-width: 768px
  • large - min-width: 992px
  • xlarge - min-width: 1200px
Custom breakpoints can be defined by passing an object containing the breakpoint property specifying the min-width in pixels. Example:
responsive: {
    small: {
        display: 'bottom'
    },
    custom: { // Custom breakpoint
        breakpoint: 600,
        display: 'center'
    },
    large: {
        display: 'bubble'
    }
}
rows Number 3 Number of visible rows on the wheel. The default value depends on the theme:

Mobiscroll: 5
Bootstrap: 3
iOS: 5
Material: 3
Windows: 6
scrollLock Boolean true Disables page scrolling on touchmove (if not in inline mode, and popup height is less than window height).
showLabel Boolean true Show/hide labels above wheels.
showOnFocus Boolean false - on desktop true - on mobile Pops up the component on element focus.
showOnTap Boolean true Pops up the component on element tap.
showOverlay Boolean true Show or hide overlay.
showScrollArrows Boolean false Display scroll arrows for the wheels.
step Number 1 Defines the timer steps (in seconds). Cannot be less than 0.01.
targetTime Number undefined targetTime can be:
  • time specified in seconds to count down from or count up to.
  • undefined - targetTime can be set later by scrolling the wheels, or by the setTime method).
theme String undefined

Sets the visual appearance of the component.

If it is 'auto' or undefined, the theme will automatically be chosen based on the platform.

If the theme for the specific platform is not present, it will default to the Mobiscroll theme.

Supplied themes:
  • 'bootstrap' - Bootstrap themes
  • 'ios' - iOS theme
  • 'material' - Material theme
  • 'mobiscroll' - Mobiscroll theme
  • 'windows' - Windows theme
It's possible to modify theme colors or create custom themes.
Starting from v4.9.0 setting directly the dark version of the theme is deprecated. Use the themeVariant option instead to control the light / dark appearance of the theme.
Make sure that the theme you set is included in the downloaded package.
themeVariant String undefined

Controls which variant of the theme will be used (light or dark).

Possible values:
  • 'light' - Use the light variant of the theme.
  • 'dark' - Use the dark variant of the theme.
  • 'auto' or undefined - Detect the preferred system theme on devices where this is supported.

If not set, only the theme setting will determine which theme to use.

To use the option with custom themes, make sure to create two custom themes, where the dark version has the same name as the light one, suffixed with '-dark', e.g.: 'my-theme' and 'my-theme-dark'.

The option will not have any effect if the theme option explicitly sets the dark version of a theme, e.g. theme: 'ios-dark'.
touchUi Boolean true

Use true to render a touch optimized user interface, or false for a user interface optimized for pointer devices (mouse, touchpad).

Can be used with the responsive option to change the user interface based on viewport width.

useShortLabels Boolean false Use short or long labels
width Number, Array 70 Exact width of the wheels, in pixels. Wheel content will be truncated, if it exceeds the width. If number, it is applied to all wheels, if an array, it is applied to each wheel separately.

Setting options dynamically

There are two ways to modify options after initalization

  1. Using the option method.

    The option method always triggers reinitialization. Most of the settings can be updated only this way, updating without initialization has no effect, because the markup is already generated. If the scroller was visible, the reinitialization hides it and it's not shown again automatically (except in inline display mode).

    Javascript
    // Modify options
    mobiscrollInstance.option({ 
        theme: 'ios', 
        lang: 'de'
    });
    HTML
    <input id="mobiscroll"/>
  2. Modify directly the settings object.

    Useful when changing dynamic settings, which do not need redraw (e.g. readonly, calendar marked days).

    // Modify a setting
    mobiscrollInstance.settings.readonly = true;
    
    // Modify settings in an event
    mobiscroll.timer('#mobiscroll', {
        onBeforeShow: function (event, inst) {
            inst.settings.readonly = true;
        }
    });

Events

Name Description
onBeforeClose(event, inst) Triggered before the component closes. Close can be prevented by returning false from the handler function.

Parameters

  • event: Object - The event object has the following properties:
    • valueText: String - The selected value as text.
    • button: String - The name of the button which triggered the component to close ('set', or 'cancel').
  • inst: Object - The instance object of the timer.

Example

mobiscroll.timer('#mobiscroll', {
    onBeforeClose: function (event, inst) {
    }
});
onBeforeShow(event, inst) Triggered before the component is shown. It is useful if you want to modify the settings object before generating the markup. It can be used also to prevent the showing the control by returning false.

Parameters

  • event: Object - The event object.
  • inst: Object - The instance object of the timer.

Example

mobiscroll.timer('#mobiscroll', {
    onBeforeShow: function (event, inst) {
    }
});
onCancel(event, inst) Allows you to define your own event when cancel is pressed.

Parameters

  • event: Object - The event object has the following properties:
    • valueText: String - The selected value as text.
  • inst: Object - The instance object of the timer.

Example

mobiscroll.timer('#mobiscroll', {
    onCancel: function (event, inst) {
    }
});
onChange(event, inst) Allows you to define your own event when a wheel value is changed.

Parameters

  • event: Object - The event object has the following properties:
    • valueText: String - The selected value as text.
  • inst: Object - The instance object of the timer.

Example

mobiscroll.timer('#mobiscroll', {
    onChange: function (event, inst) {
    }
});
onClear(event, inst) Triggered when the value is cleared.

Parameters

  • event: Object - The event object.
  • inst: Object - The instance object of the timer.

Example

mobiscroll.timer('#mobiscroll', {
    onClear: function (event, inst) {
    }
});
onClose(event, inst) Triggered when the component is closed.

Parameters

  • event: Object - The event object has the following properties:
    • valueText: String - The selected value as text.
  • inst: Object - The instance object of the timer.

Example

mobiscroll.timer('#mobiscroll', {
    onClose: function (event, inst) {
    }
});
onDestroy(event, inst) Triggered when the component is destroyed.

Parameters

  • event: Object - The event object.
  • inst: Object - The instance object of the timer.

Example

mobiscroll.timer('#mobiscroll', {
    onDestroy: function (event, inst) {
    }
});
onFinish(event, inst) Gets called when 0 (if count down) or targetTime (if count up) is reached.

Parameters

  • event: Object - The event object has the following properties:
    • time: Number - The ellapsed time in milliseconds.
  • inst: Object - The instance object of the timer.

Example

mobiscroll.timer('#mobiscroll', {
    onFinish: function (event, inst) {
    }
});
onInit(event, inst) Triggered when the component is initialized.

Parameters

  • event: Object - The event object.
  • inst: Object - The instance object of the timer.

Example

mobiscroll.timer('#mobiscroll', {
    onInit: function (event, inst) {
    }
});
onItemTap(event, inst) Triggered when the user taps an item on the wheel.

Parameters

  • event: Object - The event object has the following properties:
    • target: HTMLElement - The DOM element of the tapped item.
    • selected: Boolean - Selected state of the tapped item.
  • inst: Object - The instance object of the timer.

Example

mobiscroll.timer('#mobiscroll', {
    onItemTap: function (event, inst) {
    }
});
onLap(event, inst) Gets called when the lap button is pressed.

Parameters

  • event: Object - The event object has the following properties:
    • ellapsed: Number - The ellapsed time
    • lap: Number - The last lap time.
    • laps: Array - An array with all the laps.
  • inst: Object - The instance object of the timer.

Example

mobiscroll.timer('#mobiscroll', {
    onLap: function (event, inst) {
    }
});
onMarkupReady(event, inst) Triggered when the html markup of the component is generated, but it is not yet shown. It is useful, if you want to make modifications to the markup (e.g. add custom elements), before the positioning runs.

Parameters

  • event: Object - The event object has the following properties:
    • target: Object - The DOM element containing the generated html.
  • inst: Object - The instance object of the timer.

Example

mobiscroll.timer('#mobiscroll', {
    onMarkupReady: function (event, inst) {
    }
});
onPosition(event, inst) Triggered when the component is positioned (on initial show and resize / orientation change).
Useful if dimensions needs to be modified before the positioning happens, e.g. set a custom width or height. Custom positioning can also be implemented here, in this case, returning false from the handler function will prevent the built in positioning.

Parameters

  • event: Object - The event object has the following properties:
    • target: Object - The DOM element containing the generated html.
    • windowWidth: Number - The window width.
    • windowHeight: Number - The window height.
  • inst: Object - The instance object of the timer.

Example

mobiscroll.timer('#mobiscroll', {
    onPosition: function (event, inst) {
    }
});
onReset(event, inst) Gets called the timer is reseted.

Parameters

  • event: Object - The event object.
  • inst: Object - The instance object of the timer.

Example

mobiscroll.timer('#mobiscroll', {
    onReset: function (event, inst) {
    }
});
onSet(event, inst) Triggered when a value is set.

Parameters

  • event: Object - The event object has the following properties:
    • valueText: String - The selected value as text (if any).
  • inst: Object - The instance object of the timer.

Example

mobiscroll.timer('#mobiscroll', {
    onSet: function (event, inst) {
    }
});
onShow(event, inst) Triggered when the component is shown.

Parameters

  • event: Object - The event object has the following properties:
    • target: Object - The DOM element containing the generated html.
    • valueText: String - The selected value as text.
  • inst: Object - The instance object of the timer.

Example

mobiscroll.timer('#mobiscroll', {
    onShow: function (event, inst) {
    }
});
onStart(event, inst) Gets called the timer is started.

Parameters

  • event: Object - The event object.
  • inst: Object - The instance object of the timer.

Example

mobiscroll.timer('#mobiscroll', {
    onStart: function (event, inst) {
    }
});
onStop(event, inst) Gets called the timer is stopped.

Parameters

  • event: Object - The event object has the following properties:
    • ellapsed: Number - The ellapsed time in milliseconds.
  • inst: Object - The instance object of the timer.

Example

mobiscroll.timer('#mobiscroll', {
    onStop: function (event, inst) {
    }
});

Methods

Name Description
cancel() Hides the timer and also invokes the onCancel event.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.cancel();
clear() Clears the timer value.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.clear();
destroy() Destroys the component. This will return the element back to its pre-init state.

Returns: Object

  • Returns the element back to its pre-init state.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.destroy();
disable() Disables the timer.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.disable();
enable() Enables the timer.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.enable();
getEllapsedTime() Returns the ellapsed time in milliseconds.

Returns: Number

  • The ellapsed time in milliseconds.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.getEllapsedTime();
getInst() Returns the object instance.

Returns: Object

  • The object instance.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.getInst();
getTime() Returns the target time in milliseconds.

Returns: Number

  • The target time in milliseconds.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.getTime();
getVal([temp]) Returns the selected timer value.

Parameters

  • temp (Optional): Boolean - If true, returns the temporary values (prior clicking the Set button).

Returns: String

  • The selected timer value.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.getVal();
hide([ prevAnim ] [, btn ]) Hides the component.

Parameters

  • prevAnim (Optional): Boolean - If true, hide will not be animated.
  • btn (Optional): String - Specifies which button caused the component to hide, and it's passed to the onBeforeClose event.

Example

Methods can be called on an instance. For more details see calling methods
    mobiscrollInstance.hide();
    
isVisible() Returns a boolean indicating whether the component is visible or not.

Returns: Boolean

  • True if the component is visible, false if it's not.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.isVisible();
lap() Triggers a lap event.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.lap();
option(options) Sets one or more options for the component.

Parameters

  • options: Object - A map of option-value pairs to set.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.option({
    display: 'bottom',
    lang: 'de'
});
position([check]) Recalculates the position of the component (if not inline).

Parameters

  • check (Optional): Boolean - If true, the function checks if viewport size changed after last position call, if false or ommitted, position is recalculated anyway.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.position();
reset() Resets the timer.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.reset();
select() Hides the timer and also invokes the onSet event.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.select();
setEllapsedTime(time) Sets the ellapsed time in milliseconds.

Parameters

  • time: Number - The ellapsed time in milliseconds.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.setEllapsedTime(300);
setTime() Sets the target time in milliseconds.

Parameters

  • time: Number - The ellapsed time in milliseconds.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.setTime(300);
setVal(value [, fill ] [, change ] [, temp ] [, time ]) Sets the timer value.

Parameters

  • value: String - The timer value.
  • fill (Optional): Boolean - If true, the associated input element is also updated with the new value.
  • change (Optional): Boolean - If false, change event won't be triggered on the input element.
  • temp (Optional): Boolean - If true, only temporary value is set.
  • time (Optional): Number - Specifies the duration of the animation in seconds to scroll the wheels to the new values. There is no animation, if time is omitted or 0.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.setVal('10 Minutes 30 Seconds');
show([ prevAnim ] [, prevFocus ]) Shows the component.

Parameters

  • prevAnim (Optional): Boolean - If true, show will not be animated.
  • prevFocus (Optional): Boolean - If true, the popup will not be focused right after show.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.show();
start() Starts the timer.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.start();
stop() Stops the timer.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.stop();
tap(el, handler) Attaches the handler function to the tap event of element el.

Parameters

  • el: Object - The element with tap event.
  • handler: Function - If the action was initiated with touch event, handler is called on touchend, otherwise on click.

Example

Methods can be called on an instance. For more details see calling methods
mobiscrollInstance.tap('#element', function () { alert("It's a tap!"); });

Localization

Name Type Default value Description
cancelText String 'Cancel' Text for Cancel button.
clearText String 'Clear' Text for the clear button.
headerText Boolean, String, Function '{value}' Specifies a custom string which appears in the popup header.
If the string contains '{value}' substring, it is replaced with the formatted value of the timer.
If it's set to false, the header is hidden.
If a function is passed, it receives the formatted value as parameter and the returned value appears in the header.
hideText String 'Hide' Text for hide button
labels Array ['Years', 'Months', 'Days', 'Hours', 'Minutes', 'Seconds'] Labels for the wheels
labelsShort Array ['Yrs', 'Mths', 'Days', 'Hrs', 'Mins', 'Secs'] Short labels for the wheels
lang String 'en-US' Language of the component. Based on the language string the component loads the language based default settings from the language modules.
Supported languages:
  • Arabic: 'ar'
  • Bulgarian: 'bg'
  • Catalan: 'ca'
  • Czech: 'cs'
  • Chinese: 'zh'
  • Croatian: 'hr'
  • Danish: 'da'
  • Dutch: 'nl'
  • English: 'en' or 'en-US' or undefined
  • English (UK): 'en-UK' or 'en-GB'
  • Farsi: 'fa'
  • German: 'de'
  • Greek: 'el'
  • Spanish: 'es'
  • Finnish: 'fi'
  • French: 'fr'
  • Hebrew: 'he'
  • Hindi: 'hi'
  • Hungarian: 'hu'
  • Italian: 'it'
  • Japanese: 'ja'
  • Korean: 'ko'
  • Lithuanian: 'lt'
  • Norwegian: 'no'
  • Polish: 'pl'
  • Portuguese (Brazilian): 'pt-BR'
  • Portuguese (European): 'pt-PT'
  • Romanian: 'ro'
  • Russian: 'ru'
  • Russian (UA): 'ru-UA'
  • Slovak: 'sk'
  • Serbian: 'sr'
  • Thai: 'th'
  • Swedish: 'sv'
  • Turkish: 'tr'
  • Ukrainian: 'ua'
  • Vietnamese: 'vi'
lapText String 'Lap' Text for lap button
resetText String 'Reset' Text for reset button
rtl Boolean false Right to left display.
selectedPluralText String '{count} selected' Specifies the plural form of the amount of selected items according to the rules of particular language. The '{count}' substring will be replaced with the number of selected items.
selectedText String '{count} selected' Specifies the amount of selected items according to the rules of particular language. The '{count}' substring will be replaced with the number of selected items.
setText String 'Set' Text for Set button.
startText String 'Start' Text for start button
stopText String 'Stop' Text for stop button

Customizing the appearance

While the provided pre-built themes are enough in many use cases, most of the times on top of adapting to a specific platform, you'd also like to match a brand or color scheme. Mobiscroll provides various ways to achieve this:

Override the Sass Color Variables

A convenient way to customize the colors of the Mobiscroll components is to override the Sass color variables.

Let's say your branding uses a nice red accent color, and you'd like that color to appear on the Mobiscroll components as well, while still using platform specific themes (e.g. ios on iOS devices, material on Android devices, and mobiscroll on desktop). You can override the accent color for every theme:

$mbsc-ios-accent: #e61d2a;
$mbsc-material-accent: #e61d2a;
$mbsc-mobiscroll-accent: #e61d2a;

@import "~@mobiscroll/Javascript/dist/css/mobiscroll.javascript.scss"
It's important that you override the variables BEFORE the scss file import, otherwise it won't make any difference.
Here's a complete guide on how to set up Mobiscroll with SASS support

You can also customize the colors on many levels:

  1. Theme specific variables (ex. $mbsc-material-background, $mbsc-ios-dark-text) are applied to all components in a theme. Complete list of variables here.
  2. Component specific global variables (ex. $mbsc-card-background-light, $mbsc-listview-text-dark) are applied to all themes for a specific component.
  3. Component and theme specific variables (ex. $mbsc-ios-dark-form-background, $mbsc-material-input-text) are applied to a specific theme and a specific component.

Global variables

These variables are applied to all base themes: iOS, material, windows and mobiscroll.
They all come in pairs. One for the light and one for the dark variant in each theme.

Variable name Description
$mbsc-frame-background-light Sets the background color of the Timer
$mbsc-frame-background-dark
$mbsc-frame-text-light Sets the text color of the Timer
$mbsc-frame-text-dark
$mbsc-frame-accent-light Sets the accent color of the Timer
$mbsc-frame-accent-dark
$mbsc-frame-overlay-light Sets the color of the overlay, when the Timer is shown as a modal
$mbsc-frame-overlay-dark

If you really want to get sophisticated or if a color doesn't look good on a specific theme and you want to overwrite it, you can fine tune all of the above variables individually for each theme. Below are the complete list of variables broken down to themes:

iOS theme

Variable name Default value Description
$mbsc-ios-frame-background
#ffffff
The Timer background color
$mbsc-ios-frame-text
#000000
The Timer text color
$mbsc-ios-frame-accent
#007bff
The Timer accent color
$mbsc-ios-frame-overlay
rgba(0, 0, 0, 0.2)
Sets the color of the overlay, when the Timer is shown as a modal

iOS Dark theme

$mbsc-ios-dark-frame-background
#0f0f0f
The Timer background color
$mbsc-ios-dark-frame-text
#ffffff
The Timer text color
$mbsc-ios-dark-frame-accent
#ff8400
The Timer accent color
$mbsc-ios-dark-frame-overlay
rgba(255, 255, 255, .1)
Sets the color of the overlay, when the Timer is shown as a modal
Indication on what the color variables affect

Windows theme

Variable name Default value Description
$mbsc-windows-frame-background
#1a1a1a
The Timer background color
$mbsc-windows-frame-text
#262626
The Timer text color
$mbsc-windows-frame-accent
#0078d7
The Timer accent color
$mbsc-windows-frame-overlay
rgba(0, 0, 0, .7)
Sets the color of the overlay, when the Timer is shown as a modal

Windows Dark theme

Variable name Default value Description
$mbsc-windows-dark-frame-background
#191919
The Timer background color
$mbsc-windows-dark-frame-text
#ffffff
The Timer text color
$mbsc-windows-dark-frame-accent
#0078d7
The Timer accent color
$mbsc-windows-dark-frame-overlay
rgba(0, 0, 0, .7)
Sets the color of the overlay, when the Timer is shown as a modal
Indication on what the color variables affect

Material theme

Variable name Default value Description
$mbsc-material-frame-background
#eeeeee
The Timer background color
$mbsc-material-frame-text
#5b5b5b
The Timer text color
$mbsc-material-frame-accent
#009688
The Timer accent color
$mbsc-material-frame-overlay
rgba(0, 0, 0, .6)
Sets the color of the overlay, when the Timer is shown as a modal

Material Dark theme

Variable name Default value Description
$mbsc-material-dark-frame-background
#303030
The Timer background color
$mbsc-material-dark-frame-text
#c2c2c2
The Timer text color
$mbsc-material-dark-frame-accent
#81ccc4
The Timer accent color
$mbsc-material-dark-frame-overlay
rgba(0, 0, 0, .6)
Sets the color of the overlay, when the Timer is shown as a modal
Indication on what the color variables affect

Mobiscroll theme

Variable name Default value Description
$mbsc-mobiscroll-frame-background
#f7f7f7
The Timer background color
$mbsc-mobiscroll-frame-text
#454545
The Timer text color
$mbsc-mobiscroll-frame-accent
#4eccc4
The Timer accent color
$mbsc-mobiscroll-frame-overlay
rgba(0, 0, 0, .7)
Sets the color of the overlay, when the Timer is shown as a modal

Mobiscroll Dark theme

Variable name Default value Description
$mbsc-mobiscroll-dark-frame-background
#263238
The Timer background color
$mbsc-mobiscroll-dark-frame-text
#f7f7f7
The Timer text color
$mbsc-mobiscroll-dark-frame-accent
#4fccc4
The Timer accent color
$mbsc-mobiscroll-dark-frame-overlay
rgba(0, 0, 0, .7)
Sets the color of the overlay, when the Timer is shown as a modal
Indication on what the color variables affect

Timer
Basic usage
Component
<!-- the simple default -->
<mbsc-timer [(ngModel)]="elapsed">Countdown</mbsc-timer>
<!-- setting theme and other options inline -->
<mbsc-timer theme="ios" display="top" [(ngModel)]="ellapsed">Countdown</mbsc-timer>
<!-- passing event handlers -->
<mbsc-timer (onFinish)="finished()">Timer</mbsc-timer>
export class MyExampleClass {
finished() {
alert("Time's up!");
}
}
If you need more customization options on the element, you can use the directives as follows
Directive
@Component({
selector: 'my-example',
template: `<input [(ngModel)]="ellapsed" mbsc-timer />`
})
export class MyExampleComponent {
ellapsed: number;
}
import { MbscTimerOptions } from '../lib/mobiscroll/js/mobiscroll.angular.min.js';
@Component({
selector: 'my-example',
template: `<input [(ngModel)]="ellapsed" mbsc-timer [mbsc-options]="myOptions" />`
})
export class MyExampleComponent {
ellapsed: number;
myOptions: MbscTimerOptions = {
theme: 'ios',
display: 'bottom'
}
}
Using with Ionic
<ion-item>
<ion-label>Ellapsed</ion-label>
<ion-input [(ngModel)]="ellapsed" mbsc-timer></ion-input>
</ion-item>
Modules
The MbscTimerModule can be used to import all the directives and components from below.
Directives
| Directive | Data type | Description |
|---|---|---|
| [(mbsc-timer)] | string | Directve for the timer scroller |
| [mbsc-options] | MbscTimerOptions | Directive used to pass the mobiscroll options |
Components
| Component | Description |
|---|---|
| <mbsc-timer> | Component for the timer control |
The following options can be used as attributes to customize the component.
For many more examples - simple and complex use-cases - check out the timer demos for angular.
Options
| Name | Type | Default value | Description |
|---|---|---|---|
| anchor | String, HTMLElement | undefined |
Specifies the anchor element for positioning, if display is set to
'bubble'
.
If undefined, it defaults to the element on which the component was initialized.
|
| animate | String or Boolean | undefined |
Animation to use for show/hide (if display is not inline). Possible values:
false, turns the animation off.
|
| autostart | Boolean | false |
If true, the timer will automatically start on initialization. |
| buttons | Array | ['resetlap', 'toggle'] |
List of buttons to display. Possible values:
|
| circular | Boolean, Array | undefined |
If true, the scroll wheels are circular.
If an array, it can be specified as a per wheel configuration,
e.g. for 3 wheels: [true, false, false] - sets the first wheel circular.
If not specified, if a wheel has more values than the number of displayed rows, the scroll wheel becomes circular.
|
| closeOnOverlayTap | Boolean | true |
If true, the popup is closed on overlay tap/click. |
| context | String, HTMLElement | 'body' |
The DOM element in which the component is appended and positioned (if not inline). Can be a selector string or a DOM element. |
| cssClass | String | undefined |
Applies custom css class to the top level element. |
| disabled | Boolean | false |
Initial disabled state of the component. This will take no effect in inline display mode. |
| display | String | 'center' |
Controls the positioning of the component. Possible options:
|
| focusOnClose | Boolean, String, HTMLElement |
true
|
Element to focus after the popup is closed.
If undefined, the original element will be focused.
If false, no focusing will occur.
|
| focusTrap | Boolean | true |
If not in inline mode, focus won't be allowed to leave the popup. |
| headerText | Boolean, String, Function | false |
Specifies a custom string which appears in the popup header. If the string contains the '{value}' substring, it is replaced with the formatted value of the timer.If it's set to false, the header is hidden.If a function is passed, it receives the formatted value as parameter and the returned value appears in the header. |
| height | Number | 40 |
Height in pixels of one item on the wheel.
The default value depends on the theme: Mobiscroll: 40 Android Holo: 36 Bootstrap: 40 iOS: 34 jQuery Mobile: 40 Material: 40 Windows Phone: 76 |
| layout | String | undefined |
Sets the layout of the component. Possible values:
|
| maxWheel | String | undefined |
Specifies the highest wheel to display.
If not set, the highest wheel is calculated based on the targetTime setting. Possible values:
|
| maxWidth | Number or Array | undefined |
Maximum width of the wheels. If number, it is applied to all wheels, if an array, it is applied to each wheel separately. |
| minWidth | Number or Array | 80 |
Minimum width of the wheels in pixels. If number, it is applied to all wheels, if an array, it is applied to each wheel separately.
The default value depends on the theme: Mobiscroll: 80 Android Holo: 76 Bootstrap: 80 iOS: 55 jQuery Mobile: 80 Material: 80 Windows Phone: 76 |
| mode | String | 'countdown' |
Option to choose between modes. Possible values:
|
| multiline | Number | 1 |
If greater than 1, the wheel item's content will be wrapped into the specified number of lines. If the content is shorter, it will remain vertically centered. |
| readonly | Boolean or Array | false |
If true, the component is displayed, but the values are not selectable.
If an array, it can be specified as a per wheel configuration,
e.g. for 3 wheels: [true, false, false] - sets the first wheel readonly.
|
| responsive | Object | undefined |
Specify different settings for different container widths, in a form of an object,
where the keys are the name of the breakpoints, and the values are objects containing
the settings for the given breakpoint.
The available width is queried from the container element of the component and not the browsers viewport like in css media queries
There are five predefined breakpoints:
breakpoint
property specifying the min-width in pixels.
Example:
|
| rows | Number | 3 |
Number of visible rows on the wheel.
The default value depends on the theme: Mobiscroll: 5 Bootstrap: 3 iOS: 5 Material: 3 Windows: 6 |
| scrollLock | Boolean | true |
Disables page scrolling on touchmove (if not in inline mode, and popup height is less than window height). |
| showLabel | Boolean | true |
Show/hide labels above wheels. |
| showOnFocus | Boolean |
false - on desktop
true - on mobile
|
Pops up the component on element focus. |
| showOnTap | Boolean | true |
Pops up the component on element tap. |
| showOverlay | Boolean | true |
Show or hide overlay. |
| showScrollArrows | Boolean | false |
Display scroll arrows for the wheels. |
| step | Number | 1 |
Defines the timer steps (in seconds). Cannot be less than 0.01. |
| targetTime | Number | undefined |
targetTime can be:
|
| theme | String | undefined |
Sets the visual appearance of the component.
If it is If the theme for the specific platform is not present, it will default to the Mobiscroll theme. Supplied themes:
Starting from v4.9.0 setting directly the dark version of the theme is deprecated.
Use the themeVariant option instead to control the light / dark appearance of the theme.
Make sure that the theme you set is included in the downloaded package.
|
| themeVariant | String | undefined |
Controls which variant of the theme will be used (light or dark). Possible values:
If not set, only the theme setting will determine which theme to use.
To use the option with custom themes, make sure to create two custom themes,
where the dark version has the same name as the light one, suffixed with
The option will not have any effect if the theme option explicitly
sets the dark version of a theme, e.g.
theme: 'ios-dark'.
|
| touchUi | Boolean | true |
Use Can be used with the responsive option to change the user interface based on viewport width. |
| useShortLabels | Boolean | false |
Use short or long labels |
| width | Number, Array | 70 |
Exact width of the wheels, in pixels. Wheel content will be truncated, if it exceeds the width. If number, it is applied to all wheels, if an array, it is applied to each wheel separately. |
Setting options dynamically
There are two ways to modify options after initalization
-
Using the option method.
The option method always triggers reinitialization. Most of the settings can be updated only this way, updating without initialization has no effect, because the markup is already generated. If the scroller was visible, the reinitialization hides it and it's not shown again automatically (except in inline display mode).
Here is an example for the dynamic option changeimport { ViewChild } from '@angular/core'; @Component({ selector: 'my-example', template: ` <input mbsc-timer #myVariable="mobiscroll" [(ngModel)]="myExample"/> <button (click)="changeOptions()">Change theme and language</button> ` }) export class MyExample { @ViewChild('myVariable') myRef: any; // Modify options changeOptions() { this.myRef.instance.option({ theme: 'mobiscroll', lang: 'de' }); } } -
Modify directly the
settingsobject.
Useful when changing dynamic settings, which do not need redraw (e.g. readonly, calendar marked days).
Exampleimport { ViewChild } from '@angular/core'; @Component({ selector: 'my-example', template: ` <input mbsc-timer #myVariable="mobiscroll" [mbsc-options]="myOptions"/> <button (click)="changeOptions()">Change readonly</button> ` }) export class MyExample { @ViewChild('myVariable') myRef: any; // get instance and modify a setting changeOptions() { this.myRef.instance.settings.readonly = true; } // Modify settings in an event myOptions: any = { onBeforeShow: (event, inst) => { inst.settings.readonly = true; } } }
Events
this reference.| Name | Description | |
|---|---|---|
| onBeforeClose(event, inst) |
Triggered before the component closes. Close can be prevented by returning false from the handler function.
Parameters
Example
|
|
| onBeforeShow(event, inst) |
Triggered before the component is shown.
It is useful if you want to modify the settings object before generating the markup.
It can be used also to prevent the showing the control by returning false.
Parameters
Example
|
|
| onCancel(event, inst) |
Allows you to define your own event when cancel is pressed.
Parameters
Example
|
|
| onChange(event, inst) |
Allows you to define your own event when a wheel value is changed.
Parameters
Example
|
|
| onClear(event, inst) |
Triggered when the value is cleared.
Parameters
Example
|
|
| onClose(event, inst) |
Triggered when the component is closed.
Parameters
Example
|
|
| onDestroy(event, inst) |
Triggered when the component is destroyed.
Parameters
Example
|
|
| onFinish(event, inst) | Gets called when 0 (if count down) or targetTime (if count up) is reached.
Parameters
Example
|
|
| onInit(event, inst) |
Triggered when the component is initialized.
Parameters
Example
|
|
| onItemTap(event, inst) |
Triggered when the user taps an item on the wheel.
Parameters
Example
|
|
| onLap(event, inst) | Gets called when the lap button is pressed.
Parameters
Example |
|
| onMarkupReady(event, inst) |
Triggered when the html markup of the component is generated, but it is not yet shown.
It is useful, if you want to make modifications to the markup (e.g. add custom elements), before the positioning runs.
Parameters
Example
|
|
| onPosition(event, inst) |
Triggered when the component is positioned (on initial show and resize / orientation change).
Useful if dimensions needs to be modified before the positioning happens, e.g. set a custom width or height. Custom positioning can also be implemented here, in this case, returning false from the handler
function will prevent the built in positioning.
Parameters
Example
|
|
| onReset(event, inst) | Gets called the timer is reseted.
Parameters
Example
|
|
| onSet(event, inst) |
Triggered when a value is set.
Parameters
Example
|
|
| onShow(event, inst) |
Triggered when the component is shown.
Parameters
Example
|
|
| onStart(event, inst) | Gets called the timer is started.
Parameters
Example
|
|
| onStop(event, inst) | Gets called the timer is stopped.
Parameters
Example
|
|
Methods
| Name | Description | |
|---|---|---|
| cancel() |
Hides the timer and also invokes the onCancel event.
ExampleMethods can be called on an instance. For more details see calling methods
|
|
| clear() |
Clears the timer value.
ExampleMethods can be called on an instance. For more details see calling methods
|
|
| disable() |
Disables the timer.
ExampleMethods can be called on an instance. For more details see calling methods
|
|
| enable() |
Enables the timer.
ExampleMethods can be called on an instance. For more details see calling methods
|
|
| getEllapsedTime() | Returns the ellapsed time in milliseconds.
Returns: Number
ExampleMethods can be called on an instance. For more details see calling methods
|
|
| getTime() | Returns the target time in milliseconds.
Returns: Number
ExampleMethods can be called on an instance. For more details see calling methods
|
|
| getVal([temp]) | Returns the selected timer value.
Parameters
Returns: String
ExampleMethods can be called on an instance. For more details see calling methods
|
|
| hide([ prevAnim ] [, btn ]) |
Hides the component.
Parameters
ExampleMethods can be called on an instance. For more details see calling methods
|
|
| isVisible() |
Returns a boolean indicating whether the component is visible or not.
Returns: Boolean
ExampleMethods can be called on an instance. For more details see calling methods
|
|
| lap() | Triggers a lap event.
ExampleMethods can be called on an instance. For more details see calling methods
|
|
| option(options) |
Sets one or more options for the component.
Parameters
ExampleMethods can be called on an instance. For more details see calling methods
|
|
| position([check]) |
Recalculates the position of the component (if not inline).
Parameters
ExampleMethods can be called on an instance. For more details see calling methods
|
|
| reset() |
Resets the timer.
ExampleMethods can be called on an instance. For more details see calling methods
|
|
| select() |
Hides the timer and also invokes the
onSet
event.
ExampleMethods can be called on an instance. For more details see calling methods
|
|
| setEllapsedTime(time) | Sets the ellapsed time in milliseconds.
Parameters
ExampleMethods can be called on an instance. For more details see calling methods
|
|
| setTime() | Sets the target time in milliseconds.
Parameters
ExampleMethods can be called on an instance. For more details see calling methods
|
|
| setVal(value [, fill ] [, change ] [, temp ] [, time ]) |
Sets the timer value.
Parameters
ExampleMethods can be called on an instance. For more details see calling methods
|
|
| show([ prevAnim ] [, prevFocus ]) |
Shows the component.
Parameters
ExampleMethods can be called on an instance. For more details see calling methods
|
|
| start() | Starts the timer.
ExampleMethods can be called on an instance. For more details see calling methods
|
|
| stop() | Stops the timer.
ExampleMethods can be called on an instance. For more details see calling methods
|
|
| tap(el, handler) |
Attaches the handler function to the tap event of element el.
Parameters
ExampleMethods can be called on an instance. For more details see calling methods
|
|
Localization
| Name | Type | Default value | Description |
|---|---|---|---|
| cancelText | String | 'Cancel' |
Text for Cancel button. |
| clearText | String | 'Clear' |
Text for the clear button. |
| headerText | Boolean, String, Function | '{value}' |
Specifies a custom string which appears in the popup header. If the string contains '{value}' substring, it is replaced with the formatted value of the timer. If it's set to false, the header is hidden. If a function is passed, it receives the formatted value as parameter and the returned value appears in the header. |
| hideText | String | 'Hide' |
Text for hide button |
| labels | Array | ['Years', 'Months', 'Days', 'Hours', 'Minutes', 'Seconds'] |
Labels for the wheels |
| labelsShort | Array | ['Yrs', 'Mths', 'Days', 'Hrs', 'Mins', 'Secs'] |
Short labels for the wheels |
| lang | String | 'en-US' |
Language of the component. Based on the language string the component loads the language based default settings from the
language modules.
Supported languages:
|
| lapText | String | 'Lap' |
Text for lap button |
| resetText | String | 'Reset' |
Text for reset button |
| rtl | Boolean | false |
Right to left display. |
| selectedPluralText | String | '{count} selected' |
Specifies the plural form of the amount of selected items according to the rules of particular language. The '{count}' substring will be replaced with the number of selected items. |
| selectedText | String | '{count} selected' |
Specifies the amount of selected items according to the rules of particular language. The '{count}' substring will be replaced with the number of selected items. |
| setText | String | 'Set' |
Text for Set button. |
| startText | String | 'Start' |
Text for start button |
| stopText | String | 'Stop' |
Text for stop button |
Customizing the appearance
While the provided pre-built themes are enough in many use cases, most of the times on top of adapting to a specific platform, you'd also like to match a brand or color scheme. Mobiscroll provides various ways to achieve this:
- Create custom themes using the theme builder - the custom themes can be also built using out theme builder, on a graphical user interface, without any coding, or the need for Sass support in your project.
- Create custom themes using Sass - use this, if you need multiple themes with different color variatons, in case you have pages with different colors, or you'd like to users to customize the colors of your app.
- Override the Sass color variables - the straightforward way to change the colors in one place throughout the application.
Override the Sass Color Variables
A convenient way to customize the colors of the Mobiscroll components is to override the Sass color variables.
Let's say your branding uses a nice red accent color, and you'd like that color to appear on the Mobiscroll components as well,
while still using platform specific themes (e.g. ios on iOS devices, material on Android devices, and mobiscroll on desktop).
You can override the accent color for every theme:
$mbsc-ios-accent: #e61d2a;
$mbsc-material-accent: #e61d2a;
$mbsc-mobiscroll-accent: #e61d2a;
@import "~@mobiscroll/Angular/dist/css/mobiscroll.angular.scss"
You can also customize the colors on many levels:
- Theme specific variables (ex.
$mbsc-material-background,$mbsc-ios-dark-text) are applied to all components in a theme. Complete list of variables here. - Component specific global variables (ex.
$mbsc-card-background-light,$mbsc-listview-text-dark) are applied to all themes for a specific component. - Component and theme specific variables (ex.
$mbsc-ios-dark-form-background,$mbsc-material-input-text) are applied to a specific theme and a specific component.
Global variables
These variables are applied to all base themes: iOS, material, windows and mobiscroll.
They all come in pairs. One for the light and one for the dark variant in each theme.
| Variable name | Description |
|---|---|
| $mbsc-frame-background-light | Sets the background color of the Timer |
| $mbsc-frame-background-dark | |
| $mbsc-frame-text-light | Sets the text color of the Timer |
| $mbsc-frame-text-dark | |
| $mbsc-frame-accent-light | Sets the accent color of the Timer |
| $mbsc-frame-accent-dark | |
| $mbsc-frame-overlay-light | Sets the color of the overlay, when the Timer is shown as a modal |
| $mbsc-frame-overlay-dark |
If you really want to get sophisticated or if a color doesn't look good on a specific theme and you want to overwrite it, you can fine tune all of the above variables individually for each theme. Below are the complete list of variables broken down to themes:
iOS theme
| Variable name | Default value | Description |
|---|---|---|
| $mbsc-ios-frame-background | #ffffff | The Timer background color |
| $mbsc-ios-frame-text | #000000 | The Timer text color |
| $mbsc-ios-frame-accent | #007bff | The Timer accent color |
| $mbsc-ios-frame-overlay | rgba(0, 0, 0, 0.2) | Sets the color of the overlay, when the Timer is shown as a modal |
iOS Dark theme
| $mbsc-ios-dark-frame-background | #0f0f0f | The Timer background color |
| $mbsc-ios-dark-frame-text | #ffffff | The Timer text color |
| $mbsc-ios-dark-frame-accent | #ff8400 | The Timer accent color |
| $mbsc-ios-dark-frame-overlay | rgba(255, 255, 255, .1) | Sets the color of the overlay, when the Timer is shown as a modal |
Windows theme
| Variable name | Default value | Description |
|---|---|---|
| $mbsc-windows-frame-background | #1a1a1a | The Timer background color |
| $mbsc-windows-frame-text | #262626 | The Timer text color |
| $mbsc-windows-frame-accent | #0078d7 | The Timer accent color |
| $mbsc-windows-frame-overlay | rgba(0, 0, 0, .7) | Sets the color of the overlay, when the Timer is shown as a modal |
Windows Dark theme
| Variable name | Default value | Description |
|---|---|---|
| $mbsc-windows-dark-frame-background | #191919 | The Timer background color |
| $mbsc-windows-dark-frame-text | #ffffff | The Timer text color |
| $mbsc-windows-dark-frame-accent | #0078d7 | The Timer accent color |
| $mbsc-windows-dark-frame-overlay | rgba(0, 0, 0, .7) | Sets the color of the overlay, when the Timer is shown as a modal |
Material theme
| Variable name | Default value | Description |
|---|---|---|
| $mbsc-material-frame-background | #eeeeee | The Timer background color |
| $mbsc-material-frame-text | #5b5b5b | The Timer text color |
| $mbsc-material-frame-accent | #009688 | The Timer accent color |
| $mbsc-material-frame-overlay | rgba(0, 0, 0, .6) | Sets the color of the overlay, when the Timer is shown as a modal |
Material Dark theme
| Variable name | Default value | Description |
|---|---|---|
| $mbsc-material-dark-frame-background | #303030 | The Timer background color |
| $mbsc-material-dark-frame-text | #c2c2c2 | The Timer text color |
| $mbsc-material-dark-frame-accent | #81ccc4 | The Timer accent color |
| $mbsc-material-dark-frame-overlay | rgba(0, 0, 0, .6) | Sets the color of the overlay, when the Timer is shown as a modal |
Mobiscroll theme
| Variable name | Default value | Description |
|---|---|---|
| $mbsc-mobiscroll-frame-background | #f7f7f7 | The Timer background color |
| $mbsc-mobiscroll-frame-text | #454545 | The Timer text color |
| $mbsc-mobiscroll-frame-accent | #4eccc4 | The Timer accent color |
| $mbsc-mobiscroll-frame-overlay | rgba(0, 0, 0, .7) | Sets the color of the overlay, when the Timer is shown as a modal |
Mobiscroll Dark theme
| Variable name | Default value | Description |
|---|---|---|
| $mbsc-mobiscroll-dark-frame-background | #263238 | The Timer background color |
| $mbsc-mobiscroll-dark-frame-text | #f7f7f7 | The Timer text color |
| $mbsc-mobiscroll-dark-frame-accent | #4fccc4 | The Timer accent color |
| $mbsc-mobiscroll-dark-frame-overlay | rgba(0, 0, 0, .7) | Sets the color of the overlay, when the Timer is shown as a modal |